#!/usr/bin/python
#VulnTrack by Ogma
#License: GPL
#            .__       .___.__                     
#  __________ |  |    __| _/|__| ______________  ___
# /  ___/  _ \|  |   / __ | |  |/ __ \_  __ \  \/  /
# \___ (  <_> )  |__/ /_/ | |  \  ___/|  | \/>    < 
#/____  >____/|____/\____ | |__|\___  >__|  /__/\_ \
#     \/                 \/         \/            \/
#				www.soldierx.com
import requests
import httplib
import re
import sys
import os
import sqlite3
import vulndb
import zlib
import csv
import sys
import lxml.html
from lxml import etree as ET
reload(sys)
sys.setdefaultencoding('utf-8')


config = ET.parse('config.xml')
config_root = config.getroot()



########################################################################
#							FEED STUFF									
########################################################################

# Function to grab feeds (either nist or exploit-db)
def getFeed(source):
	headers = {'User-Agent':'Mozilla/5.0(Windows; u; windows NT 6.1;en-US) AppleWebKit/533.4 (KHTML, like Gecko) Chrome//5.0.375.126 Safari//5.33.4'}
	# Get different feeds
	if source == "nist":
		r = requests.get("https://nvd.nist.gov/feeds/xml/cve/nvdcve-2.0-Recent.xml.gz", headers=headers)
		data = zlib.decompress(r.content, 16+zlib.MAX_WBITS)
	elif source == "exploit-db":
		r = requests.get("https://www.exploit-db.com/rss.xml", headers=headers, verify=False)
		data = r.content
	else:
		print "Error: Unknown datasource"
		sys.exit(1)

	return data

def fileFeed():
	f = open("nvd-rss.xml", "r")
	return f.read()

def getExploits(db, exploityear="2016", last_edbid=False):
	db = vulndb.db()
	r = requests.get("https://raw.githubusercontent.com/offensive-security/exploit-database/master/files.csv")
	data = r.text.splitlines()
	c = 0
	
	try:
		reader = csv.reader(data)
		sortedlist = sorted(reader, key=lambda row: row[0], reverse=True)
		for row in sortedlist:
			if c != 0:
				year = row[3].split('-')[0]
				category = row[1].split("/")[2]
				if year >= exploityear:
					if category != "shellcode":
						edbid = row[1].split('/')[3].split('.')[0]
						# If we are picking up from the last edbid in the database
						if last_edbid:
							if edbid == str(last_edbid):
								break
						
						cve = checkexploitcve(edbid)
						#                 edbid, :cve, :date, :platform, :description
						date = row[3].split('-')
						date = date[1] + '-' + date[2] + '-' + date[0]
						print "Inserting:",edbid, cve, date, category, row[2]
						db.insertexploit(edbid, cve, date, category, unicode(row[2]))
			c = 1
	finally:
		print "done"

def checkexploitcve(edbid):
	headers = {'User-Agent':'Mozilla/5.0(Windows; u; windows NT 6.1;en-US) AppleWebKit/533.4 (KHTML, like Gecko) Chrome//5.0.375.126 Safari//5.33.4'}
	r = requests.get("https://www.exploit-db.com/exploits/"+edbid, headers=headers)
	pagetree = lxml.html.fromstring(r.content)
	cvenum = pagetree.xpath('//a[contains(@href, "CVE")]/@href')
	# Some exploits don't have an associated CVE
	if len(cvenum) > 0:
		return cvenum[0][-13:]
	else:
		return ""


########################################################################
#							VULN L-LIST									
#				Makes it easier to work with the data
########################################################################

class Vuln(object):
    def __init__(self, data=None, next_node=None):
        self.data = data
        self.next_node = next_node

    def get_data(self):
        return self.data

    def get_next(self):
        return self.next_node

    def set_next(self, new_next):
        self.next_node = new_next

class VulnList(object):
    def __init__(self, head=None):
        self.head = head

    def insert(self,data):
        new_vuln = Vuln(data)
        new_vuln.set_next(self.head)
        self.head = new_vuln

    def search(self, data, terms, group="Default", DataBase=None):
		current = self.head
		r = re.compile(data, re.IGNORECASE)
		while current:
			if r.search(current.data[1]):
				# If we are going to add the object to a list of matched vulnerabilities
				if DataBase: 
					# Adding to the list of Matched Vulnerabilities
					print "%s matched based on %s." % (current.data[0], terms)
					DataBase.insert(current.data, group, terms)
				else: # Otherwise just print it out (for debugging and testing purposes
						print "CVE:", current.data[0] 
						print "Link:", current.data[1] 
						print "Description:", current.data[2]
						print "Date:", current.data[3]
						print "========================================="

			current = current.get_next()

    def walk(self, callback=None):
        current = self.head
        while current:
			if(callback == None):
				# Print matched vulnerabilities to the screen
				print current.data[0] # CVE
				print current.data[1] # Link
				print current.data[2] # Description
				print current.data[3] # date
			else:
				callback(current)
            
			current = current.get_next()

########################################################################
#							MAIN FUNCTION								
########################################################################

if __name__ == "__main__":
	if len(sys.argv) > 1:
		search = sys.argv[1]
	else:
		search = "CSRF"

	# Initialize database...
	db = vulndb.db()
	# create a list to hold the entire feed
	Vulns = VulnList()
	# create a list to hold matched vulnerabilities GOING AWAY????
	MatchedVulns = VulnList()
	# get nist feed and set xml root
	feed = getFeed("nist")
	root = ET.fromstring(feed)

	nsvuln = {'vuln':'http://scap.nist.gov/schema/vulnerability/0.4'}
	nscvss = {'cvss':'http://scap.nist.gov/schema/cvss-v2/0.2'}
	# Populate database with exploits from exploit-db
	
	if db.exploitcount() == 0:
		getExploits(db, "2016")
	else:
		last_edbid = db.lastexploit()[0][0]
		getExploits(db, "2016",last_edbid)
		
		# Add new exploits to the VulnList so they can be checked against the search terms as well
		recentexploits = db.recentexploits(last_edbid)
		for r in recentexploits:
			exploit = []
			# CVE
			exploit.append("None")
			# Description
			exploit.append(r[4])
			# Date
			exploit.append(r[2])
			# Score
			exploit.append("N/A")
			# Difficulty
			exploit.append("N/A")
			# Vector
			exploit.append(r[3])
			# Versions
			exploit.append(" ")
			# References
			references = []
			references.append("https://www.exploit-db.com/exploits/" + str(r[0]) )
			exploit.append(references)
			Vulns.insert(exploit)

	for i in root:
		# Test if CVSS is available
		cvss = i.find('vuln:cvss', nsvuln)
		if cvss is not None:
			info = []
			info.append(i.get("id")) # CVE
			info.append(i.find('vuln:summary',nsvuln).text) # Description
			info.append(i.find('vuln:published-datetime', nsvuln).text) # Date

			# CVSS
			for c in cvss:
				info.append(c[0].text) # Score
				info.append(c[2].text) # Difficulty
				info.append(c[1].text) # Vector

			# Effected Versions
			versions = []
			for v in i.findall('vuln:vulnerable-software-list',nsvuln):
				for ver in v:
					versions.append(ver.text)
			info.append(versions)

			# References
			references = []
			for r in i.findall('vuln:references', nsvuln):
				for ref in r:
					href = ref.get("href")
					if href:
						references.append(href)
						
			info.append(references)
			Vulns.insert(info)

    #Vulns.search(search)
	for group in config_root.findall('group'):
		for term in group.findall('term'):
			searchstring = "(?=.*" + term.get('value') + ")"
			searchterms = term.get('value')
			condition_and = term.get('and')
			if condition_and:
				searchstring += "(?=.*" + condition_and + ")"
				searchterms += " and " + condition_and
				
			if len(term):
				for ex in term.findall('exclude'):
					searchstring += "(?!.*" + ex.text + ")^.*$"
					searchterms += " excluding" + ex.text
					
			Vulns.search(searchstring, searchterms, group.get("value"), db)

	MatchedVulns.walk()
    
    
